//  A POV-Ray v1.0 include file
//
//  A magnifying glass:
//
//  composite { Magnifying_Glass } along the Y-axis, handle pointing up.
//  Dimensions:
//     x:  -7.0 ...   7.0
//     y: -13.5 ...  13.5
//     z:  -2.0 ...   2.0
//
//  Object created by Jussi Kantola				    (16/07/93)
//  email: jute@sday.pulp.nullnet.fi
//

#include "textures.inc"

//
// This torus created by Truman's Torus Generator 1.0 (c) 1991 Truman Brown
//   Torus specs:
//	Major radius: 1.300000
//	Minor radius: 0.100000
//	Outer radius: 1.400000
//	Inner radius: 1.200000
//

#declare Torus01 =
   quartic {
   <    1.000000 0.000000 0.000000 0.000000 2.000000
        0.000000 0.000000 2.000000 0.000000 -3.400000
        0.000000 0.000000 0.000000 0.000000 0.000000
        0.000000 0.000000 0.000000 0.000000 0.000000
        1.000000 0.000000 0.000000 2.000000 0.000000
        3.360000 0.000000 0.000000 0.000000 0.000000
        1.000000 0.000000 -3.400000 0.000000 2.822400 >
    }

//
//  Wood from CHESS.POV by Ville Saari, try this too, looks great!
//  (Even BETTER?!)
//

#declare BWood = texture {
   wood
   turbulence 0.1
   colour_map {
      [ 0.0 0.55 colour red 0.45 green 0.25
      colour red 0.45 green 0.25 ]
      [ 0.55 1.0 colour red 0.30 green 0.16
      colour red 0.30 green 0.16 ]
   }
   scale <0.3 1000.0 0.3>
   translate <100.0 0.0 -200.0>
   specular 1
   roughness 0.02
}

//
//	Conserve memory...
//

#declare DMFWood4b = texture { DMFWood4 scale <5 10 5> rotate <90 0 0> }

//
// We're building the handle now... I know, the construction is a bit
// weird, but... well, at least we get to bound nicely :).
//

#declare Handle_1 = object
// x: -2.....2
// y: -10.2..2	--scaled--> -6.1..6.1
// z: -2.....2
//
   {
   union
      {
      sphere { <0 0 0> 2 }
      intersection
	 {
	 quadric { Paraboloid_Y }
	 plane { <0 1 0> 4 }
	 plane { <0 1 0> 1.44 inverse }
	 translate <0 -2.72 0>
	 scale <1 3.90625 1>
	 translate <0 -5 0>
	 }
      quadric { Ellipsoid scale <1.9 .2 1.9> translate <0 -10 0> }
      }
   bounded_by { box { <-2 -10.2 -2> <2 2 2> } }
	 texture { DMFWood4b }
   color Tan
   }

#declare Handle_2 = object
// x: -1.2...1.2
// y: -1.44..1.44 ---> -12.88..-10
// z: -1.2...1.2
//
   {
   quadric { Hyperboloid_Y scale <1 2 1 > }
   clipped_by { box { <-1.44 -1.44 -1.44> <1.44 1.44 1.44> } }
   bounded_by { box { <-1.44 -1.44 -1.44> <1.44 1.44 1.44> } }
   translate <0 -11.44 0>
	 texture { DMFWood4b }
   color Tan
   }

#declare Handle_3 = object  // BAD BAD object designing!  But it works...
   {
// x: -1.7...1.7
// y: -15.1..-12.68
// z: -1.7...-1.7
//
   union
      {
      quadric { Ellipsoid scale <1.7 .2 1.7> translate <0 -12.88 0> }
      intersection { Disk_Y scale <1.2 1.1 1.2> translate <0 -13.88 0> }
      quartic { Torus01 translate <0 -15 0> }  // NNNICE!  Look closely!
      }
   bounded_by { box { <-1.7 -15.1 -1.7> <1.7 -12.68 1.7> } }
   texture { Chrome_Metal }
   color Gray70
   }

//
//  Here's the frame holding the lens.
//

#declare Lens_Frame = object
   {
   intersection
      {
      quadric { Cylinder_Z scale <7 7 1> }
      quadric { Cylinder_Z scale <6.9 6.9 1> inverse }
      plane { <0 0 1> 1.8 }
      plane { <0 0 -1> 1.8 }
      }
   bounded_by { box { <-7 -7 -1.8> <7 7 1.8> } }
   translate <0 -22 0>
   texture { Chrome_Metal }
   color Gray70
   }

#declare Lens_X = 6.9
#declare Lens_Y = 6.9
#declare Lens_Z = 0.6

//
//  A magnifying lens.	Credits for the scaling values go to Jani
//  Lehtinen, email: gadolin@gadox.pulp.nullnet.fi.  I just could
//  not figure out the correct mathemathics! <grin>
//

#declare Lens = object
   {
// x: -6.9..6.9
// y: -6.9..6.9
// z: -0.5..0.5
//
   intersection
      {
      quadric
	 {
	 Ellipsoid
	 scale <47.86 47.86 47.86>
	 translate <0 0 47.36>
	 }
      quadric
	 {
	 Ellipsoid
	 scale <47.86 47.86 47.86>
	 translate <0 0 -47.36>
         }
      }
   bounded_by { box { <-6.9 -6.9 -0.5> <6.9 6.9 0.5> } }
   texture
      {
      Glass3
			color red 0.95 green 0.98 blue 0.98 alpha 0.9
			reflection 0	// Reflective looks bad...
      refraction 1   // We want it all!
      }
   translate <0 -22 0>
   color White
   }

//
//  Join the frame and lens...
//

#declare MGlass = composite
   {
   object { Lens_Frame }
   object { Lens }
   bounded_by { box { <-7 -7 -1.8> <7 7 1.8> translate <0 -22 0> } }
   }

//
//  There!
//

#declare Magnifying_Glass = composite
//  Magnifying glass along the Y-axis, handle pointing up.
//  Dimensions:
//     x:  -7.0 ...   7.0
//     y: -13.5 ...  13.5
//     z:  -2.0 ...   2.0
//
   {
   object { Handle_1 }
   object { Handle_2 }
   object { Handle_3 }
   composite { MGlass }
   bounded_by { box { <-7 -29 -2> <7 2 2> } }
   translate <0 13.5 0>
   }

// End of File
