//  A POV-Ray v1.00 scene description file
//
//   MGMAGNET.POV ---------------
//  -------------- Jussi Kantola
//
//  Magnifying glass enlarges a portion of a magnetic fractal.
//  You need Fractint to create a gif used here.  Everything's
//  public domain, of course.
//
// Magnet	      { ; use same resolution for this as you're going
//			; to use for trace.
//   reset=1100 type=magnet2m corners=1.9116/1.9784/0.88/0.93 float=y
//   inside=0 savename=magnet.gif
//   colors=000000<15>zZ0<15>zz0<14>440<14>b7Qe8SfCU<2>iIYiKZjL_jN`kOa<4>mVen\
//   WfnXgoYhoZhp`i<29>zzz000<62>432000<46>xT0zU0yT1<13>e8Sc6Ua6S<12>312
//   }
//
//  Please, improve this scene and send it back to me then!  I lost my
//  interest in this after I got that magnifying glass ready.
//
//  email : jute@sday.pulp.nullnet.fi
//

#include "colors.inc"
#include "shapes.inc"
#include "mg.inc"
#include "stones.inc"
#default { texture { diffuse 1 } }

 #declare FoV_45 = 1.207106781

camera
   {
   location  <0 32.5 -50>
   direction <0 0 FoV_45>
   right     <1.333333 0 0>
   up        <0 1 0>
   sky	     <0 1 0>
   look_at   <0 2 0>
   }

composite
   {
   Magnifying_Glass
   rotate <25 20 -45>
   translate <2 25 -30>
   }

object
   {
   plane { <0 1 0> 0.0 }
   texture
      {
      bump_map
	 {
	 <1 0 -1> gif "magnet.gif" bump_size -8
	 }
      scale <16 1 8>
      scale <5 1 5>
      rotate <0 -30 0>
      specular 1.0
      roughness 0.001
      color red 0.39 green 0.78 blue 1.0
      }
   color Grey40
   }

object
   {
   box { <-30 0 -20> <30 3 20> }
   texture
      {
      image_map
	 {
	 <1 0 -1>
	 gif "magnet.gif" once
	 }
      translate <-0.5 0 -0.5>
      scale <2 1 2>
      scale <30 1 20>
      specular 1
      roughness 0.003
      ambient 1
      }
   rotate <0 -20 0>
   }

object
   {
   difference
      {
      box { <-30.5 0 -20.5> <30.5 3 20.5> }
      box { <-30 -0.1 -20> <30 3.1 20> }
      }
   texture { Stone13 scale <8 5 8> }
   rotate <0 -20 0>
   }

object { light_source { <-20 8 0> color White } }
object { light_source { <20 8 0> color White } }
object { light_source { <2 20 -40> color White } }
